import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

/**
 * Korn sollte auf einem Acker gest werden (durch Krner). Dann
 * wchst das Korn von allein (Methode wachse) und kann am Ende
 * geerntet werden.
 * 
 * @author T. Schaller 
 * @version 04.10.2021
 */
public class Korn extends Gegenstand
{
    public Korn() {
        super("Korn", false, true,0);
        zeichneImage();
    }

    protected void zeichneImage() {
        bildnummer = wert/15;
        super.zeichneImage();
        
    }

    public void wachse() {
        if(wert < 45) {
            wert += 1;
        }
        setzeBild(wert/15);
        Greenfoot.delay(0);
    }
    
    public void addedToWorld(World w) {
        super.addedToWorld(w);
        ((Bauernhofprojekt) w).addAktion(()->wachse());
    }    
}