import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

/**
 * Ergnzen Sie hier eine Beschreibung fr die Klasse AB_Bauer.
 * 
 * @author Thomas Schaller
 * @version 04.10.2021
 */
public class AB5_Bauer extends Bauer
{

    /** istAufLeeremAcker prft, ob der Bauer auf einem noch nicht 
     * mit Tomaten bepflanztem Acker steht.
     * @return true, wenn das zutrifft, sonst false
     */
    public boolean istAufLeeremAcker() {
        if(istAuf("Acker") && !istAuf("Tomate") ){
            return true;
        } else {
            return false;
        }
    }

    /*# 
     * Aufgabe 3: Erntebereit?
     */
    public boolean istAufReiferTomate() {
        if(istAuf("Tomate") && pruefe("Tomate") == 100) {
            return true;
        } else {
            return false;
        }
    }
    
     /*# 
     * Aufgabe 4: Giessen?
     */
    public boolean istAufDurstigerTomate() {
        if(istAuf("Tomate") && pruefe("Tomate") == -1) {
            return true;
        } else {
            return false;
        }
    }

     /*# 
     * Aufgabe 5: OutOfPower
     */
    public boolean istEnergieSchwach() {
        if(getDurst() < 40 || getHunger() <40) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * Besitztmer: Gibt zurueck, ob der Figur mindestens einen Gegenstand der angegeben Art besitzt.
     * @param name Art des gesuchten Gegenstands
     * @return true, wenn der Figur einen derartigen Gegenstand hat, sonst false
     */
    public boolean hatGegenstand(String name) {
        if (getAnzahl(name) > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    
    /*#
     * Aufgabe 7: Giebereit
     */
    public boolean kannGiessen() {
        if(hatGegenstand("Giesskanne") && pruefe("Giesskanne")>0){
            return true;
        } else {
            return false;
        }
    }
    
    /*#
     * Aufgabe 8: Blick nach links
     */
    
    public boolean istLinks(String name) {
        dreheLinks();
        if(istVorne(name)) {
            dreheRechts();
            return true;
        } else {
            dreheRechts();
            return false;
        }
    }    

     /*#
     * Aufgabe 9: Positionslauf
     */
	 public void laufeBisY(int y) {
        while(getY() != y) {
            einsVor();
        }
    }


    /*#
     * Leveltest 5: ndere den Namen dieser Methode nicht.
     */
    public void leveltest5() {
        dreheLinks();
        einsVor();
        aufnehmen();
        dreheRechts();
        benutze("Giesskanne");
        dreheRechts();
        einsVor();
        dreheLinks();
        einsVor();
        einsVor();      
        while(istAufLeeremAcker()) {
            ablegen("Tomate");
            einsVor();
        }
        while(getAnzahl("Tomate") < 20) {
            dreheRechts();
            dreheRechts();
            laufeBisY(5);
            dreheRechts();
            benutze("Giesskanne");
            if(istEnergieSchwach()) {
                dreheLinks();
                einsVor();
                vesperpause();
                laufeBisY(5);
            } else {
                dreheRechts();
            }
            einsVor();
            while(istAuf("Acker")) {
                if(istAufReiferTomate()) {
                    ernte("Tomate");
                } else {
                    if(istAufDurstigerTomate() && kannGiessen()) {
                      benutze("Giesskanne");
                    }
                }
                einsVor();
            }
        }

    }
}
