import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

/**
 * Ergnzen Sie hier eine Beschreibung fr die Klasse AB6_Huhn.
 * 
 * @author Thomas Schaller
 * @version 04.10.2021
 */
public class AB6_Huhn extends Huhn
{
    /**
     * Deklariation der Attribute
     */
    private int entfernungZumNest;
    private boolean eiGelegt;
    private int koernerGefressen;

    /**
     * Konstruktor der Klasse AB6_Huhn
     */
	public AB6_Huhn() {
        super();
        entfernungZumNest = 0;
        koernerGefressen = 0;
        eiGelegt = false;
    }

    public void dreheUm() 
    {
        dreheRechts();
        dreheRechts();
    }

	/**
     * Verwendung des Attributs
     */
    public void fresseMitZaehlen() 
    {
        fresse();
        koernerGefressen = koernerGefressen + 1;
    }

    /**
     * Gibt den Wert des Attributs zurck
     */
    public int gibAnzahlGefressenerKoerner() {
        return koernerGefressen;
    }


    /*#
     * Aufgabe 6+8: Schrittezhler
     */    
	// Aufgabe 6
    // public void sucheKoerner() 
    // {
    // while(!istAuf("Koerner")) {
    // einsVor();
    // entfernungZumNest = entfernungZumNest + 1;
    // }
    // fresseMitZaehlen();

    // }    

    // Verbesserte Version fr Aufgabe 8
    public void sucheKoerner() 
    {
        while(!istAuf("Koerner") && istVorneFrei()) {
            einsVor();
            entfernungZumNest = entfernungZumNest + 1;
        }
        if(istAuf("Koerner")){
            fresseMitZaehlen();
        }
    }    

    /*#
     * Aufgabe 7: Schrittanzeige
     */
    public int gibEntfernungZumNest() {
        return entfernungZumNest;
    }

    /*#
     * Aufgabe 9: Heimwrts
     */
    public void laufeZurueckZumNest()
    {
        dreheUm();
        while(entfernungZumNest > 0) {
            einsVor();
            entfernungZumNest = entfernungZumNest - 1;
        }
    }

 
    public void picken() {
        while(istVorneFrei()) {
            sucheKoerner();
        }
        laufeZurueckZumNest();
    }    


    /*#
     * Aufgabe 10: Jedes Huhn legt ein Ei...
     */
	public void gackere(){
        if(istAuf("Nest") && !istAuf("Ei")) {
            versucheEiZuLegen();
            if(istAuf("Ei")) {
                eiGelegt = true;
            }
        }
    }

    public boolean hatEiGelegt() {
        return eiGelegt;
    }

}