import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

/**
 * Ergnzen Sie hier eine Beschreibung fr die Klasse AB7_Bauer.
 * 
 * @author Thomas Schaller
 * @version 04.10.2021
 */
public class AB7_Bauer extends Bauer
{
    private int anzahl1;

    
    /**
   * Konstruktor der Klasse
   */
    public AB7_Bauer() {
        anzahl1 = 0;
    }
  
  /**
   * Lsst den Bauer umdrehen und in die nchste Spalte gehen
   * @param linksrum gibt an, ob sich der Bauer nach links drehen sollen. Wenn linksrum false ist, dreht er sich nach rechts.
   */
    public void umkehren(boolean linksrum) {
        if(linksrum) {
            dreheLinks();
            einsVor();
            dreheLinks();
        } else {
            dreheRechts();
            einsVor();
            dreheRechts();
        } 
    }
  
  /**
   * zhlt die Anzahl der Tomaten in einer Spalte mit Hilfe eines Attributs
   */
    public int bestimmeAnzahlTomatenAttribut() {
        if(istAuf("Tomate")) {
            anzahl1 ++;
        }
        while(istVorneFrei()) {
            einsVor();
            if(istAuf("Tomate")) {
                anzahl1 ++;
            }
        }
        return anzahl1;
    }

  /**
   * zhlt die Anzahl der Tomaten in einer Spalte mit Hilfe einer lokalen Variablen
   */
      public int bestimmeAnzahlTomatenLokaleVariable() {
        int anzahl2;
        anzahl2 = 0;
        if(istAuf("Tomate")) {
            anzahl2 ++;
        }
        while(istVorneFrei()) {
            einsVor();
            if(istAuf("Tomate")) {
                anzahl2 ++;
            }
        }
        return anzahl2;
    }

    /*#
     * Aufgabe 5: Feldlnge 1
     */
    public int bestimmeLaenge() {
        int anzahlSchritte;
        anzahlSchritte = 0;
        while(istVorneFrei()) {
            einsVor();
            anzahlSchritte++;
        }
        return anzahlSchritte+1;
    }

     /*#
     * Aufgabe 6: Feldlnge 2
     */
     public int bestimmeLaenge2() {
        int y1;
        int y2;
        int diff_y;
        y1 = getY();
        while(istVorneFrei()) {
            einsVor();
        }
        y2 = getY();
        diff_y = Math.abs(y2-y1);

        return diff_y+1;
    }

    /*#
     * Aufgabe 7: Flche
     */
     public int bestimmeFlaeche() {
        int laenge;
        int breite;
        laenge = bestimmeLaenge();
        dreheLinks();
        breite = bestimmeLaenge();
        return laenge*breite;
    }

    /*#
     * Aufgabe 8: lstiges Unkraut
     */
     public int zaehleUnkraut() {
        int anzahl = 0;
        while(istVorneFrei()) {
            if(istAuf("Gras") ) {
                anzahl++;
            }
            einsVor();
        }
        if(istAuf("Gras")) {
            anzahl++;
        }
        return anzahl;
    }

    /*#
     * Aufgabe 9: Blumenbeet
     */
     public int anzahlSchrittBisBlume3() {
        int blumeNr;
        int schritte;
        blumeNr = 0;
        schritte = 0;
        while(blumeNr < 3) {
            if(istAuf("Blume")){
                blumeNr++;
            }
            if(blumeNr < 3) {
                einsVor();
                schritte++;
            }
        }
        return schritte;
    }

    /*# 
     * Aufgabe 11: Pflanze Korn
     */
     public void pflanzeKorn(int anzahl) {
        int i;
        i = 0;
        // while(i < anzahl) {

        while(i < anzahl-1) {
            ablegen("koerner");
            einsVor();
            i++;
        }
        // Zunchst weglassen
        ablegen("koerner");
    }

    public void pflanzeKorn2(int anzahl) {
        // for(int i=0; i<anzahl; i++) {
        // ablegen("koerner");
        // einsVor();
        // }
        for(int i=0; i<anzahl-1; i++) {
            ablegen("koerner");
            einsVor();
        }
        ablegen("koerner");

    }

    /*#
     * Aufgabe 13: Drehwurm
     */
     public void drehwurm(int anzahl) {
        for(int i=0; i< anzahl*4; i++) {
            dreheLinks();
        }
        for(int i=0; i< anzahl*4; i++) {
            dreheRechts();
        }
    }


    /*#
     * Aufgabe 14: Kornfeld
     */
     public void ernteKorn(int anzahl) {
        for(int i=0; i<anzahl-1; i++) {
            ernte("korn");
            einsVor();
        }
        ernte("korn");
    }

    public void kornfeld(int laenge, int breite) {
        boolean naechsteDrehungLinks = true;
        for(int i=0; i< breite-1; i++) {
            if(istAuf("Korn")) {
                ernteKorn(laenge);
            } else {
                pflanzeKorn(laenge);
            }
            umkehren(naechsteDrehungLinks);
            naechsteDrehungLinks = !naechsteDrehungLinks;
        }
        if(istAuf("Korn")) {
            ernteKorn(laenge);
        } else {
            pflanzeKorn(laenge);
        }
    }

    /*#
     * Leveltest 7: Kornbauernprfung
     */
     public void leveltest7() {
        int laenge;
        int breite;
        laenge = bestimmeLaenge();
        dreheLinks();
        breite = bestimmeLaenge();
        dreheLinks();

        for(int i=0; i< laenge-1; i++) einsVor();
        dreheLinks();
        for(int i=0; i< breite-1; i++) {
            if(getX()==10) {
                dreheRechts();
                vesperpause();
                einsVor();
                dreheRechts();
            }
            einsVor();
        }
        einsVor();
        aufnehmen();
        dreheRechts();
        dreheRechts();
        einsVor();
        dreheRechts();
        while(getAnzahl("Koerner") <300) {
            kornfeld(laenge, breite);
            dreheLinks();
            dreheLinks();
            for(int i=0; i< laenge-1; i++) einsVor();
            dreheLinks();
            for(int i=0; i< breite-1; i++) {
                if(getX()==10) {
                    dreheRechts();
                    vesperpause();
                    einsVor();
                    dreheRechts();
                }
                einsVor();
            }
            dreheLinks();
        }

    }
}
