import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)
import java.util.Random;
/**
 * Die Klasse Blume definiert verschiedenfarbige Blumen.
 * Je nach Farbe liefern sie unterschiedlich viel Energie oder
 * sind sogar giftig.
 * Werden sie abgefressen, wchst nur Gras nach.
 * 
 * @author T. Schaller 
 * @version 04.10.2021
 */
public class Blume extends Gegenstand
{
     public Blume() {
        super("Blume",true, true,0);
        setzeBild(-1); 
        zeichneImage();
    }



    public void abfressen() {
        Gegenstand g = Gegenstand.erzeuge("Gras");
        g.setzeBild(0);
        getWorld().addObject(g, getX(), getY());
        getWorld().removeObject(this);
    }


    
    public void setzeBild(int nr)  {
        Random r = new Random();
        if(nr < 0 || nr > 2) nr = r.nextInt(3);
        wert = 0;
        if (nr==0) wert = 30;
        if (nr==1) wert = -40;
        if (nr==2) wert = 40;
        super.setzeBild(nr);
        zeichneImage();
    }
    

}