import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)
import java.util.Random;
/**
 * Gras wchst allmhlich nach (Methode wachse), bis Stufe 15 erreicht ist.
 * Das Bild passt sich an. Wenn es abgefressen wird, kehrt es
 * auf Stufe 0 zurck.
 * 
 * @author T. Schaller 
 * @version 04.10.2021
 */
public class Gras extends Gegenstand 
{
    public Gras() {
        super("Gras",false, true,0);
        Random r = new Random();
        wert = r.nextInt(16); 
        zeichneImage();
    }



    public void abfressen() {
        wert = 0;
        zeichneImage();
    }

    protected void zeichneImage() {
        bildnummer = wert/5;
        super.zeichneImage();
        
    }

    public void wachse() {
        if(wert < 15) {
            wert += 1;
        }
        zeichneImage();
        Greenfoot.delay(0);
    }
    
    public void setzeBild(int nr)  {
        if(nr>= 0 && nr < 4) {
           wert = nr*5;
        } else {
           Random r = new Random();
           wert = r.nextInt(16); 
        }
        zeichneImage();
    }
    
    public void addedToWorld(World w) {
        super.addedToWorld(w);
        ((Bauernhofprojekt) w).addAktion(()->wachse());
    }    
}