import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

/**
 * Ergnzen Sie hier eine Beschreibung fr die Klasse AB8_Bauer.
 * 
 * @author Schaller 
 * @version 04.10.21
 */
public class AB8_Bauer extends Bauer
{
    private int[]    anzahlBlumen;
    private int[]    anzahlEier;
    private int      nestNr;
    private String[] namen ={"Frieda", "Helene","Rosi","Hanni", "Ruberta", "Elenor", "Xantippe"};

    
    public AB8_Bauer() {
        super();

        // Initialisierung fr die Blumen
        anzahlBlumen = new int[3];
        anzahlBlumen[0] = 0;
        anzahlBlumen[1] = 0;
        anzahlBlumen[2] = 0;

        // Initialisierung fr die Eier
        anzahlEier = new int[26];
        for(int i=0; i<26; i++) {
            anzahlEier[i] = 0;
        }
    }

    // --------------------------- Blumen -----------------------------------------
    
    public void pflueckeBlumen() {
        // Schlerversion
        // while(getDurst()>10) {
        // aufnehmen();
        // if(istVorneFrei()) {
        // einsVor();
        // } else {
        // if(getRotation() == 90) {
        // dreheLinks();
        // einsVor();
        // dreheLinks();
        // } else {
        // if(istRechtsFrei()) {
        // dreheRechts();
        // einsVor();
        // dreheRechts();
        // } else {
        // dreheLinks();
        // while(istVorneFrei()) {
        // einsVor();
        // }
        // dreheLinks();
        // }
        // }
        // }

        // }

        while(getDurst()>10) {
            // Zhlen
            if(pruefe("Blume") ==-40) anzahlBlumen[0]++;
            if(pruefe("Blume") == 30) anzahlBlumen[1]++;
            if(pruefe("Blume") == 40) anzahlBlumen[2]++;

            // Aufsammeln
            aufnehmen();

            
            // Laufen
            if(istVorneFrei()) {
                einsVor();
            } else {
                // Drehung linksrum
                if(getRotation() == 90) {
                    dreheLinks();
                    einsVor();
                    dreheLinks();
                } else {
                    // Drehung rechtsrum
                    if(istRechtsFrei()) {
                        dreheRechts();
                        einsVor();
                        dreheRechts();
                    } else {
                        // Zurck zur Startposition
                        dreheLinks();
                        while(istVorneFrei()) {
                            einsVor();
                        }
                        dreheLinks();
                    }
                }
            }

        }
    }

    public int gibAnzahlBlumenart(int art) {
        return anzahlBlumen[art];
    }

    public int gibGesamtzahlBlumen() {
        return anzahlBlumen[0]+anzahlBlumen[1]+anzahlBlumen[2];
    }

    public double gibProzentsatz(int art) {
        return (double) gibAnzahlBlumenart(art)/gibGesamtzahlBlumen();
    }

    public int gibNrHaeufigsteBlume() {
       int haeufigste = 0;
        if(anzahlBlumen[1] > anzahlBlumen[0]) haeufigste =1;
        if(anzahlBlumen[2] > anzahlBlumen[haeufigste]) haeufigste = 2;
        return haeufigste;
    }

    public int gibAnzahlHaeufigsteBlume() {
        return anzahlBlumen[gibNrHaeufigsteBlume()];
    }

    
    public int zaehle(int b, int h) {
        for(int x=0; x < b; x++) {
            for(int y=0; y < h; y++) {
                einsVor();
            }
            dreheRechts();
            dreheRechts();
            for(int y=0; y < h; y++) {
                einsVor();
            }
            dreheRechts();
            einsVor();
            dreheRechts();
        }
        return 0;
    }
            
    // --------------------------------- Eier -------------------------------------------
    
    public void laufeSchritte(int anzahl) {
        for(int i=0; i<anzahl; i++) {
            einsVor();
            if(istAuf("Nest")) {
                if(istAuf("Ei")) {
                    aufnehmen();
                    anzahlEier[nestNr]++;
                }
                nestNr++;
            }

        }
    }

    public void sammleEier() {
        for(int j=0; j < 30; j++) {
            nestNr =0;
            dreheRechts();
            laufeSchritte(9);
            dreheLinks();
            laufeSchritte(3);
            dreheLinks();
            laufeSchritte(5);
            dreheRechts();
            laufeSchritte(4);
            dreheLinks();
            laufeSchritte(6);
            dreheLinks();
            laufeSchritte(7);
            dreheLinks();
            laufeSchritte(2);
            dreheRechts();
            vesperpause();
            einsVor();
        }
    }

    public int gibAnzahlEierInNest(int nestNr) {
        return anzahlEier[nestNr];
    }

    public int gibGesamtzahlEier() {
        int summe = 0;
        for(int i=0; i<anzahlEier.length; i++) {
            summe = summe + anzahlEier[i];
        }
        return summe;
    }

    public double gibDurchschnitt() {
        double durchschnitt = (double) gibGesamtzahlEier() / anzahlEier.length;
        return durchschnitt;
    }

    public int gibAnzahlLeererNester() {
        int anzahl = 0;
        for(int i=0; i<anzahlEier.length; i++) {
            if(anzahlEier[i] == 0) {
                anzahl++;
            }
        }
        return anzahl;
    }

    public int gibNrBestesNest() {
        int bestes = 0;
        for(int i=1; i<anzahlEier.length; i++) {
            if(anzahlEier[i] > anzahlEier[bestes]) {
                bestes = i;
            }
        }
        return bestes;
    }

    public int gibAnzahlEierBestesNest() {
        return gibAnzahlEierInNest(gibNrBestesNest());
    }

    public String gibAlleZahlen() {
        String s = "";
        for(int i=1; i<anzahlEier.length; i++) {
            s = s + anzahlEier[i] + ", ";
        }
        return s;
    }


    public void vertausche(int i , int j) {
        String dummy = namen[i];
        namen[i] = namen[j];
        namen[j] = dummy;
        int dummy2 = anzahlEier[i];
        anzahlEier[i] = anzahlEier[j];
        anzahlEier[j] = dummy2;
    }

    public String leveltest8() {
        // for(int runden = 0; runden < 20; runden++) {
        // dreheRechts();
        // einsVor();
        // while(getX() != 10 || getY() != 3) {
        // if(istRechtsFrei() && getY() > 3) {
        // dreheRechts();
        // einsVor();
        // } else {
        // if(istVorneFrei()) {
        // einsVor();
        // } else {
        // dreheLinks();
        // }
        // }
        // if(istAuf("Ei")) aufnehmen();
        // }
        // dreheRechts();
        // vesperpause();
        // einsVor();
        // }

        int huhnNr;
        for(int runden = 0; runden < 20; runden++) {
            huhnNr = -1;
            dreheRechts();
            einsVor();
            while(getX() != 10 || getY() != 3) {
                if(istRechtsFrei() && getY() > 3) {
                    dreheRechts();
                    einsVor();
                } else {
                    if(istVorneFrei()) {
                        einsVor();
                    } else {
                        dreheLinks();
                    }
                }
                if(istAuf("Gras")) huhnNr++;
                if(istAuf("Ei")) {
                    aufnehmen();
                    anzahlEier[huhnNr]++;
                }
            }
            dreheRechts();
            vesperpause();
            einsVor();
        }

        for(int j=1; j<7; j++) {
            for(int i=1; i<7; i++) {
                if(anzahlEier[i] < anzahlEier[i-1]) vertausche(i, i-1);
            }
        }
        
        String text = "";
        for(int i=0; i<7; i++) {
            text = text + namen[i]+":"+anzahlEier[i]+" ";
        }
        return text;
    }

    
}
