import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

/**
 * Ergnzen Sie hier eine Beschreibung fr die Klasse Message.
 * 
 * @author T. Schaller 
 * @version 04.10.2021
 */
public class Message extends Actor
{
    /**
     * Act - tut, was auch immer Message tun will. Diese Methode wird aufgerufen, 
     * sobald der 'Act' oder 'Run' Button in der Umgebung angeklickt werden. 
     */
    private boolean small = false;
    public Message (String text) {
        changeText(text);
    }

    public Message (String text, boolean small) {
        this.small = small;
        changeText(text);
    }
    
    public void changeText(String text) {
     if(!small) {
            GreenfootImage t = new GreenfootImage(text,30, new Color(255,255,255),new Color(200,100,100,0));
            GreenfootImage mitRand = new GreenfootImage(t.getWidth()+60, t.getHeight()+30);
            mitRand.setColor(new Color(150,50,50,220));
            mitRand.fillRect(0,0, mitRand.getWidth(), mitRand.getHeight());
            mitRand.drawImage(t, 30, 15);
            setImage(mitRand);
        }
        else {
            GreenfootImage t = new GreenfootImage(text,15, new Color(255,255,255),new Color(150,150,150,0));
            GreenfootImage mitRand = new GreenfootImage(t.getWidth()+10, t.getHeight()+6);
            mitRand.setColor(new Color(150,150,150,220));
            mitRand.fillRect(0,0, mitRand.getWidth(), mitRand.getHeight());
            mitRand.drawImage(t, 5, 3);
            setImage(mitRand);
        }
    }
}