import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)
import java.util.*;
/**
 * Die Klasse Schaf definiert die Grundfunktionen fr ein Schaf
 * Es kann umherlaufen, fressen und trinken. Es frisst gerne 
 * Gras und Blumen.
 * 
 * @author T. Schaller 
 * @version 04.10.2021
 */
public class Schaf extends Figur
{
    public Schaf() {
        super("Schaf");

    }

    /**
     * lsst das Schaf Gras oder Blumen fressen, wenn es darauf steht.
     * Gras muss gengend gewachsen sein.
     * Je saftiger das Gras, deste mehr Energie bringt es. Blumen 
     * lassen sich immer fressen, aber Achtung: es gibt auch giftig Blumen,
     * die Energie abziehen.
     */
    public void fresse() {
        if(getWorld() == null) return;

        Gegenstand g = gibGegenstandUnterFigur();
        if(g!= null && ((g.getName().equals("Gras") && g.getWert()>=5) || g.getName().equals("Blume"))) {
            setzeBild(bildnummer+4);
            Greenfoot.delay(3);
            hunger += g.getWert();
            if(hunger>100) hunger =100;
            if(g instanceof Gras)  ((Gras) g).abfressen();
            if(g instanceof Blume)  ((Blume) g).abfressen();
            
            setzeBild(bildnummer-4);
        }
        else {
            warne("Da ist nichts zum Fressen!",this);
        }

    }

    /**
     * lsst das Schaf Wasser trinken, wenn es vor einem Feld mit Wasser
     * steht.
     */
    public void trinke() {
         if(getWorld() == null) return;
      
        Gegenstand g = gibGegenstandVorFigur("Wasser");

        if(g!= null) {
            setzeBild(bildnummer+4);
            Greenfoot.delay(3);
            durst += 25;
            if(durst>100) durst =100;
            setzeBild(bildnummer-4);
        } else {
            warne("Da ist nichts zum Trinken!",this);
        }
    }

   

}